
--**********************************************************************--
--** 				             FIND X-PLANE DATAREFS            	   **--
--**********************************************************************--

Bat =  find_dataref("sim/cockpit2/electrical/Battery_Power")
Grd_Speed = find_dataref ("sim/flightmodel/position/groundspeed")
Gr_On_Ground = find_dataref ("sim/flightmodel/failures/onground_all")
Belt_On = find_dataref ("sim/cockpit2/annunciators/fasten_seatbelt")
FLdoor = find_dataref ("sim/flightmodel2/misc/custom_slider_ratio[0]")
BLdoor = find_dataref ("sim/flightmodel2/misc/custom_slider_ratio[1]")
FRdoor = find_dataref ("sim/flightmodel2/misc/custom_slider_ratio[2]")
BRdoor = find_dataref ("sim/flightmodel2/misc/custom_slider_ratio[3]")
Park = find_dataref("sim/cockpit2/controls/parking_brake_ratio")
Eng1 =  find_dataref("sim/flightmodel2/engines/engine_is_burning_fuel[0]")
Eng2 = find_dataref("sim/flightmodel2/engines/engine_is_burning_fuel[1]")
Light1 = find_dataref("sim/cockpit2/switches/landing_lights_switch[3]")
Light2 = find_dataref("sim/cockpit2/switches/landing_lights_switch[2]")
VSpeed = find_dataref("sim/cockpit2/gauges/indicators/vvi_fpm_pilot")
Airborne = find_dataref("sim/flightmodel/state/Airborne")
Altitude =  find_dataref("sim/cockpit2/gauges/indicators/radio_altimeter_height_ft_pilot")
--**********************************************************************--
--** 				        CREATE READ-ONLY CUSTOM DATAREFS           **--
--***********************************************************************--

--PA  -------------------------------------------------------------
Boarding = create_dataref("sim/sounds/PA/Boarding", "number")
Taxi = create_dataref("sim/sounds/PA/Taxi", "number")
After_Takeoff = create_dataref("sim/sounds/PA/After_Takeoff", "number")
After_Landing = create_dataref("sim/sounds/PA/After_Landing", "number")
Gate_Arv = create_dataref("sim/sounds/PA/Gate_Arv", "number")
Approach = create_dataref("sim/sounds/PA/Approach", "number")
Descent = create_dataref("sim/sounds/PA/Descent", "number")
DeBoard = create_dataref("sim/sounds/PA/DeBoard", "number")
Takeoff = create_dataref("sim/sounds/PA/Takeoff", "number")
in_Cruise = create_dataref("sim/sounds/PA/in_Cruise", "number")
--Debug -------------------------------------------------------------
Gear_Roll = create_dataref("sim/flightmodel/state/Gear_Roll", "number")
CruiseAlt = create_dataref("sim/flightmodel/state/CruiseAlt", "number")
F_Roll = create_dataref("sim/flightmodel/state/F_Roll", "number")


function Aircraft_Pos()

-- Flight Phases -----------------------------

	if Airborne == 1 then
		if Altitude > 18000 then
		   CruiseAlt = 1
		 elseif Airborne == 0  then
		   CruiseAlt = 0
		end
	end
	
	if Gr_On_Ground == 1 then
		if Airborne == 1 then
		   in_Ground = 1
		 elseif Airborne == 0  then
		   in_Ground = 0
		end
	end


      if Gr_On_Ground == 1 then  
	      if Grd_Speed > 5 then
	      Gear_Roll = 1
	      end
      end
	  
	  
      if Gr_On_Ground == 1 then  
	      if Grd_Speed > 6 then
	      Gear_Roll = 1
	      end
      end
	 
	  if Gear_Roll == 1 then  
	      if Grd_Speed > 15 then
	      F_Roll = 1
	      end
	end
	
-- Boarding  & Takeoff----------------------------

Light = Light1 + Light2
Doors = FLdoor + BLdoor + FRdoor + BRdoor 

-- Boarding ----------------------------

	if Airborne == 0 then 
	      if Doors < 0.1 then
                if Belt_On >= 1 and Gear_Roll == 0 and Light == 0 then  
	           Boarding = 1
		      end
		end
	end	
-- Taxi----------------------------
	
	 if Airborne == 0 then
	 	 if Doors < 0.1   then 
                if Belt_On >= 1 and Gear_Roll == 1 and Light == 0 then  
			 Taxi = 1
			 Boarding = 0
		      end
	      end
	end
	
-- Takeoff----------------------------

	 if Airborne == 0 then 
	      if Doors < 0.1 then
		      if F_Roll == 0 then
                     if  Belt_On >= 1 and Gear_Roll == 1 and Light >= 1 then 
     			 Takeoff = 1
     			 Taxi = 0
     		      Boarding = 0	
     			 end
			elseif F_Roll == 1 then 
			Takeoff = 0
    			Taxi = 0
     		 Boarding = 0
			 end
		 end
	end
-- After Takeoff----------------------------

	if Airborne == 1 then 
	      if Grd_Speed > 80 then
		     if ( Altitude > 3000 and Altitude < 10000 ) then
	 	           if Belt_On >= 1 and VSpeed > 10 and CruiseAlt == 0 then
				 After_Takeoff = 1
				 Takeoff = 0
		           Boarding = 0
	                Taxi = 0
			      end
 			 end
		 end
	end
		
	
-- Cruise----------------------------

	if Airborne == 1 then 
		 if Grd_Speed > 80 and Altitude > 12000 then
		      if Belt_On == 0 and Light == 0 and VSpeed > 5 then
				 in_Cruise = 1
				 After_Takeoff = 0
				 Takeoff = 0
		           Boarding = 0
	                Taxi = 0
			 end
		 end
	 end
	 

-- Descent  ---------------------------------------------------------------

      if CruiseAlt == 1 and Grd_Speed > 80 then
           if (Altitude < 16000 and Altitude > 12000) then 
                if Belt_On >= 1 then
	           Descent = 1
			 in_Cruise = 0
			 After_Takeoff = 0
			 Takeoff = 0
	           Boarding = 0
                Taxi = 0
	           end
		 end
	 end
	
--  Approach ---------------------------------------------------------------

	if CruiseAlt == 1 and Grd_Speed > 80 then
           if  Altitude < 5000 and Belt_On >= 1 then
		 Approach = 1
           Descent = 0
		 in_Cruise = 0
		 After_Takeoff = 0
		 Takeoff = 0
           Boarding = 0
           Taxi = 0
		 end
	end

-- Landing ----------------------------------------------------------------

	if in_Ground == 1 and CruiseAlt == 1 then
	      if Grd_Speed < 20 and Belt_On >= 1 then
		 After_Landing = 1
		 Approach = 0
		 Descent = 0
		 in_Cruise = 0
		 After_Takeoff = 0
		 Takeoff = 0
           Boarding = 0
           Taxi = 0
	      end
     end
	 
	 -- Gate Arrival ---------------------------------------------------------------

Engines = Eng1 + Eng2
	if in_Ground == 1 and CruiseAlt == 1 then 
      	if Grd_Speed < 1 and Park >= 1 and Belt_On == 0 and Engines == 0 then
			Gate_Arv = 1
	      end
      end
		   
-- DeBoarding ---------------------------------------------------------------
	   
	if Gate_Arv == 1 and Doors >= 1 then
		     DeBoard = 1
			Gate_Arv = 0
      end
end

----------------------------------------------------------------------------

function after_physics()
	 Aircraft_Pos() 
end